# -*- coding: utf-8 -*-
#MoxBreakdown  2021.11.29  MayaLT対応
import maya.cmds as cmds

class MoxBreakdownClass():
    def __init__(self):
        self.MoxBreakdown()
        
    def keyBreakdown(self):#実行する
        cmds.undoInfo(openChunk=True)
        inBlend = cmds.floatSliderGrp("inBlend", q=1, value=1)
        currentFrame = cmds.currentTime(q=True) #カレントフレームを取得
        
        first = cmds.findKeyframe(timeSlider=1, which="first")
        last = cmds.findKeyframe(timeSlider=1, which="last")
        if currentFrame==first or currentFrame==last:pass

        else:
            for oSel in cmds.ls(sl=True):
        
                prev = cmds.findKeyframe( timeSlider=1, which="previous")
                next = cmds.findKeyframe( timeSlider=1, which="next")
                prevKeyVal_T = list(cmds.getAttr(oSel+".t", time=prev)[0])
                nextKeyVal_T = list(cmds.getAttr(oSel+".t", time=next)[0])
                prevKeyVal_R = list(cmds.getAttr(oSel+".r", time=prev)[0])
                nextKeyVal_R = list(cmds.getAttr(oSel+".r", time=next)[0])
                prevKeyVal_S = list(cmds.getAttr(oSel+".s", time=prev)[0])
                nextKeyVal_S = list(cmds.getAttr(oSel+".s", time=next)[0])
        
                #前後のキーの値から、割合に応じた値を取り出す。
                combinedT = [x+((y-x)*inBlend)  for (x, y) in zip(prevKeyVal_T, nextKeyVal_T)]
                combinedR = [x+((y-x)*inBlend)  for (x, y) in zip(prevKeyVal_R, nextKeyVal_R)]
                combinedS = [x+((y-x)*inBlend)  for (x, y) in zip(prevKeyVal_S, nextKeyVal_S)]
                
                #取り出した値でキーを打つ
                cmds.setKeyframe(oSel+".tx", v=combinedT[0])
                cmds.setKeyframe(oSel+".ty", v=combinedT[1])
                cmds.setKeyframe(oSel+".tz", v=combinedT[2])
                cmds.setKeyframe(oSel+".rx", v=combinedR[0])
                cmds.setKeyframe(oSel+".ry", v=combinedR[1])
                cmds.setKeyframe(oSel+".rz", v=combinedR[2])
                cmds.setKeyframe(oSel+".sx", v=combinedS[0])
                cmds.setKeyframe(oSel+".sy", v=combinedS[1])
                cmds.setKeyframe(oSel+".sz", v=combinedS[2])
                
                try:cmds.setAttr(oSel+".t", combinedT[0],combinedT[1],combinedT[2])
                except:pass
                try:cmds.setAttr(oSel+".r", combinedR[0],combinedR[1],combinedR[2])
                except:pass
                try:cmds.setAttr(oSel+".s", combinedS[0],combinedS[1],combinedS[2])
                except:pass
        cmds.undoInfo(closeChunk=True)

    #UI
    def MoxBreakdown(self):
        if cmds.window('MoxBreakdown', exists=True):
            cmds.deleteUI('MoxBreakdown')
            
        cmds.window('MoxBreakdown', menuBarVisible=True, tlb=True, s=1, t="MoxBreakdown", resizeToFitChildren=1, mnb=1, mxb=0)
        cmds.columnLayout('MainColumnLayout', adjustableColumn=True, rowSpacing=5, columnAttach=["both",5])
        
        cmds.floatSliderGrp("inBlend", field=1, min= 0, max= 1, value=0.5, cc="MoxBreakdownClass.keyBreakdown()", s=0.01)
        #mayaLT版では、commandやccでのメソッド呼び出しはself不可。ちゃんとクラス名を書く。
        cmds.showWindow('MoxBreakdown')
        
MoxBreakdownClass = MoxBreakdownClass()

